abstract sig FSObject {}

sig File, Dir extends FSObject {}

sig FileSystem {
  live: set FSObject,
  root: Dir & live,
  parent: (live - root) -> one (Dir & live),
  contents: (Dir & live) -> live
}
{
  // A directory is the parent of its contents and vice versa
  contents = ~parent

  // File system is connected
  live in root.*contents
}

pred show {}
run show for 5 but 1 FileSystem


pred removeAll[ s, s': FileSystem, o: FSObject ] {
  o in s.live - s.root &&
  s'.live = s.live - o.*(s.contents) &&
  s'.parent = s'.live <: s.parent
}

pred showRemove[ s, s': FileSystem, o: FSObject ] {
  s != s' &&
  removeAll[s, s', o]
}

run showRemove for 7 but 2 FileSystem, 3 Dir, 2 File

